package hmggirlfront.render.mob;

import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL12;

import gvclib.render.ModelBase_Non;
import hmggirlfront.entity.mob.EntitySCM_HYDRA;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.client.renderer.entity.RenderLiving;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.MathHelper;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import objmodel.AdvancedModelLoader;
import objmodel.IModelCustom;

@SideOnly(Side.CLIENT)
public class RenderSCM_HYDRA extends RenderLiving<EntitySCM_HYDRA>
{
    private static final ResourceLocation boatTextures = new ResourceLocation("hmggirlfront:textures/model/mob/socom/hydra.png");
    private static final IModelCustom tankk = AdvancedModelLoader.loadModel(new ResourceLocation("hmggirlfront:textures/model/mob/socom/hydra.mqo"));
    /** instance of ModelBoat for rendering */

    public RenderSCM_HYDRA(RenderManager renderManagerIn)
    {
    	super(renderManagerIn, new ModelBase_Non(),0.5F);
        this.shadowSize = 0.5F;
    }

    /**
     * Actually renders the given argument. This is a synthetic bridge method, always casting down its argument and then
     * handing it off to a worker function which does the actual work. In all probabilty, the class Render is generic
     * (Render<T extends Entity>) and this method has signature public void func_76986_a(T entity, double d, double d1,
     * double d2, float f, float f1). But JAD is pre 1.5 so doe
     */
    float iii;
    public void doRender(EntitySCM_HYDRA entity, double x, double y, double z, float entityYaw, float partialTicks)
    {
        this.bindEntityTexture(entity);
		
		
        GL11.glPushMatrix();//glstart
		GL11.glTranslatef((float) x, (float) y, (float) z);
		GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
		GL11.glEnable(GL12.GL_RESCALE_NORMAL);
		float f = this.interpolateRotation(entity.prevRenderYawOffset, entity.renderYawOffset, partialTicks);
		float f8 = this.handleRotationFloat(entity, partialTicks);
		this.applyRotations(entity, f8, f, partialTicks);
		
		if(entity.deathTime > 0){
			GL11.glColor4f(0.7F, 0.2F, 0.2F, 1F);
		}else {
			if(entity.hurtTime > 0) {
				GL11.glColor4f(0.7F, 0.2F, 0.2F, 1F);
			}else {
				GL11.glColor4f(1F, 1F, 1F, 1F);
			}
		}
		GL11.glRotatef(-(180.0F - entity.renderYawOffset), 0.0F, 1.0F, 0.0F);
		GL11.glRotatef(180.0F - entity.rotationYawHead, 0.0F, 1.0F, 0.0F);
			tankk.renderPart("body");
			tankk.renderPart("head");
			renderleg(entity, 0.7F, 1.7F, 0F, "arm_l1_1", partialTicks, 1F, 1F, 0F, 0.5F);
			renderleg(entity, 0.7F, 1.7F, 0F, "arm_l1_2", partialTicks, 1F, 1F, 0F, 0.5F);
			renderleg(entity, 0.7F, 1.7F, -0.75F, "arm_l2", partialTicks, 0F, -1F, 0F, 0.5F);
			
			renderleg(entity, -0.7F, 1.7F, 0F, "arm_r1_1", partialTicks, -1F, 1F, 0F, 0.5F);
			renderleg(entity, -0.7F, 1.7F, 0F, "arm_r1_2", partialTicks, -1F, 1F, 0F, 0.5F);
			renderleg(entity, -0.7F, 1.7F, -0.75F, "arm_r2", partialTicks, 0F, -1F, 0F, 0.5F);
			{
				GL11.glPushMatrix();//glstart
				GL11.glTranslatef(0F, 1.3F, 0.05F);
				GL11.glRotatef(entity.rotationPitch, 1.0F, 0.0F, 0.0F);
				GL11.glTranslatef(0F, -1.3F, -0.05F);
				tankk.renderPart("gun");
				GL11.glPopMatrix();//glend
			}
			{
				GL11.glPushMatrix();//glstart
				GL11.glTranslatef(0F, 3.3F, -1.0F);
				GL11.glRotatef(entity.rotationPitch, 1.0F, 0.0F, 0.0F);
				GL11.glTranslatef(0F, -3.3F, 1.0F);
				tankk.renderPart("gun2");
				GL11.glPopMatrix();//glend
			}
		GL11.glRotatef(-(180.0F - entityYaw), 0.0F, 1.0F, 0.0F);
		
		GL11.glColor4f(1F, 1F, 1F, 1F);
		GL11.glDisable(GL12.GL_RESCALE_NORMAL);
		GL11.glPopMatrix();//glend
        super.doRender(entity, x, y, z, entityYaw, partialTicks);
    }
    
    
    public void renderleg(EntityLivingBase entity, float x, float y, float z, String name, float partialTicks, float hox, float hoy, float hoz, float level){
    	float limbSwing = this.F6(entity, partialTicks);
		float limbSwingAmount = this.F5(entity, partialTicks);
    	GL11.glPushMatrix();
    	GL11.glTranslatef(x, y, z);
    	float Ax = MathHelper.cos(limbSwing * 0.6662F + (float)Math.PI) * limbSwingAmount;
    	GL11.glRotatef(Ax * (180F / (float)Math.PI) * level, hox, hoy, hoz);
		GL11.glTranslatef(-x, -y, -z);
		tankk.renderPart(name);
		GL11.glPopMatrix();
    }
    
    public float F6(EntityLivingBase entity, float partialTicks){
 		float f6 = 0;
 		if (!entity.isRiding())
        {
            f6 = entity.limbSwing - entity.limbSwingAmount * (1.0F - partialTicks);
            if (entity.isChild())
            {
                f6 *= 3.0F;
            }
        }
 		return f6;
 	}
 	public float F5(EntityLivingBase entity, float partialTicks){
 		float f5 = 0;
 		if (!entity.isRiding())
        {
            f5 = entity.prevLimbSwingAmount + (entity.limbSwingAmount - entity.prevLimbSwingAmount) * partialTicks;
            if (f5 > 1.0F)
            {
                f5 = 1.0F;
            }
        }
 		return f5;
 	}
    
    /**
     * Returns the location of an entity's texture. Doesn't seem to be called unless you call Render.bindEntityTexture.
     */
    protected ResourceLocation getEntityTexture(EntitySCM_HYDRA entity)
    {
        return boatTextures;
    }
    
    protected void renderLivingAt(EntitySCM_HYDRA entityLivingBaseIn, double x, double y, double z)
    {
        GlStateManager.translate((float)x, (float)y, (float)z);
    }
    protected float handleRotationFloat(EntitySCM_HYDRA livingBase, float partialTicks)
    {
        return (float)livingBase.ticksExisted + partialTicks;
    }
}